unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CRVData, RVTable, ExtCtrls, RVScroll, RichView, RVEdit, RVStyle;

type
  TForm1 = class(TForm)
    RVStyle1: TRVStyle;
    RichViewEdit1: TRichViewEdit;
    Panel1: TPanel;
    RichView1: TRichView;
    procedure RichViewEdit1Change(Sender: TObject);
    procedure RichViewEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function IsEmpty(rve: TCustomRichViewEdit): Boolean;
begin
Result := (rve.ItemCount = 0) or ((rve.ItemCount = 1) and (rve.GetItemStyle(0) >= 0) and (rve.GetItemText(0) = ''));
end;

function GetCharCount(RVData: TCustomRVData): Integer;
var
i, r, c: Integer;
table: TRVTableItemInfo;
begin
Result := 0;
  for i := 0 to RVData.Items.Count - 1 do
    if RVData.GetItemStyle(i) >= 0 then
      begin
        inc(Result, RVData.ItemLength(i));
      end
        else
          if RVData.GetItemStyle(i) = rvsTab then
            inc(Result)
              else
                if RVData.GetItemStyle(i) = rvsTable then
                  begin
                    table := TRVTableItemInfo(RVData.GetItem(i));
                      for r := 0 to table.Rows.Count - 1 do
                        for c := 0 to table.Rows[r].Count - 1 do
                          if table.Cells[r, c] <> nil then
                            inc(Result, GetCharCount(table.Cells[r, c].GetRVData));
                  end;
end;

procedure TForm1.RichViewEdit1Change(Sender: TObject);
var
r: integer;
begin
r := GetCharCount(RichViewEdit1.RVData);
  Panel1.Caption := IntToStr(r);
end;

procedure TForm1.RichViewEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (not(ssCtrl in Shift)) and (Key = VK_RETURN) and (not IsEmpty(RichViewEdit1)) then
  begin
    Key := 0;
      RichViewEdit1.SelectAll;
        RichView1.AddTextFromNewLine(RichViewEdit1.GetSelText, 0);
          RichView1.Reformat;
            RichViewEdit1.Deselect;
              RichViewEdit1.Clear;
                RichViewEdit1.Reformat;
                  Panel1.Caption := '0';
  end
    else
      if (not(ssCtrl in Shift)) and (Key = VK_RETURN) and (IsEmpty(RichViewEdit1))
        then
          Key := 0;
end;

end.
